/*
Author: Neil Spencer
Creation Date: ??/??/??
Revision 1 Date: ??/??/??
Purpose: Program 4.3.1
*/

LIBNAME abcxyz 'a:\data';
LIBNAME library 'a:\formats';

PROC FORMAT LIBRARY=library.formats;
VALUE mtblab 0='No MTB' 1='MTB present';
VALUE fatlab 0='No FAT' 1='FAT present';

DATA tnfdata11;
INFILE 'a:\data\tnfdata11.dat' TRUNCOVER;
INPUT donor 1-2 rep1 3-8;
PROC SORT; BY donor;

DATA tnfdata12;
INFILE 'a:\data\tnfdata12.dat' TRUNCOVER;
INPUT donor 1-2 rep2 3-8;
PROC SORT; BY donor;

DATA tnfdata13;
INFILE 'a:\data\tnfdata13.dat' TRUNCOVER;
INPUT donor 1-2 rep3 3-8;
PROC SORT; BY donor;

DATA tnfdata1;
MERGE tnfdata11 tnfdata12 tnfdata13;
BY donor;
mtb=0; fat=0;

DATA tnfdata21;
INFILE 'a:\data\tnfdata21.dat' TRUNCOVER;
INPUT donor 1-2 rep1 3-8;
PROC SORT; BY donor;

DATA tnfdata22;
INFILE 'a:\data\tnfdata22.dat' TRUNCOVER;
INPUT donor 1-2 rep2 3-8;
PROC SORT; BY donor;

DATA tnfdata23;
INFILE 'a:\data\tnfdata23.dat' TRUNCOVER;
INPUT donor 1-2 rep3 3-8;
PROC SORT; BY donor;

DATA tnfdata2;
MERGE tnfdata21 tnfdata22 tnfdata23;
BY donor;
mtb=1; fat=0;

DATA tnfdata31;
INFILE 'a:\data\tnfdata31.dat' TRUNCOVER;
INPUT donor 1-2 rep1 3-8;
PROC SORT; BY donor;

DATA tnfdata32;
INFILE 'a:\data\tnfdata32.dat' TRUNCOVER;
INPUT donor 1-2 rep2 3-8;
PROC SORT; BY donor;

DATA tnfdata33;
INFILE 'a:\data\tnfdata33.dat' TRUNCOVER;
INPUT donor 1-2 rep3 3-8;
PROC SORT; BY donor;

DATA tnfdata3;
MERGE tnfdata31 tnfdata32 tnfdata33;
BY donor;
mtb=0; fat=1;

DATA tnfdata41;
INFILE 'a:\data\tnfdata41.dat' TRUNCOVER;
INPUT donor 1-2 rep1 3-8;
PROC SORT; BY donor;

DATA tnfdata42;
INFILE 'a:\data\tnfdata42.dat' TRUNCOVER;
INPUT donor 1-2 rep2 3-8;
PROC SORT; BY donor;

DATA tnfdata43;
INFILE 'a:\data\tnfdata43.dat' TRUNCOVER;
INPUT donor 1-2 rep3 3-8;
PROC SORT; BY donor;

DATA tnfdata4;
MERGE tnfdata41 tnfdata42 tnfdata43;
BY donor;
mtb=1; fat=1;

DATA abcxyz.tnfdata;
SET tnfdata1 tnfdata2 tnfdata3 tnfdata4;
LABEL rep1='1st replicate';
LABEL rep2='2nd replicate';
LABEL rep3='3rd replicate';
LABEL mtb='MTB presence';
LABEL fat='FAT presence';
tnfaver=(rep1+rep2+rep3)/3;
LABEL tnfaver='average TNF';
FORMAT mtb mtblab.; FORMAT fat fatlab.;

PROC PRINT DATA=abcxyz.tnfdata;

RUN;
